// vector3, matrix4x4, plane class test program
// -Kyoung Shin Park (2010 Spring)
//////////////////////////////////////////////////////////////////////
#include <iostream>
#include <glm/glm.hpp>
#include <glm/gtc/type_ptr.hpp>
#include <glm/gtc/matrix_transform.hpp>

using namespace std;
void vectorTest();

/*
typedef struct _RAY {
	vector3 p;  // start point
	vector3 u;  // direction
} RAY;

bool RayPlaneIntersection(plane p, RAY l, vector3& out)
{
    float denom = plane::dotNormal(p, l.u);     // dotNormal = a.x + b*y + c*z
	//cout << "denom       = " << denom << endl;
    if (denom == 0)
		return false;

    float t = -plane::dotCoord(p, l.p)/denom;   // dotCoord = a*x + b*y + c*z + d*1
	//cout << "t       = " << t << endl; // [0, -1, 0]
    if (t < 0)
		return false;

    out = l.p + t*(l.u);    // return vector

    return true;
}
*/

int main(int argc, char *argv[])
{
	// vector test
	cout << endl << "VECTOR" << endl;
	vectorTest();
/*
	// matrix test
	matrix4x4 A(1.0f, 0.0f, 0.0f, 0.0f,
                0.0f, 2.0f, 0.0f, 0.0f,
			    0.0f, 0.0f, 4.0f, 0.0f,
				1.0f, 2.0f, 3.0f, 1.0f);

	matrix4x4 B;
	B.identity();

	matrix4x4 C = A * B;			// multiplication
	matrix4x4 D = A.transpose();	// transpose
	float det = A.determinant();	// determinant
	matrix4x4 E = A.inverse();		// inverse
	matrix4x4 F = A * E;			// multiplication

	vector3 p(2.0f, 2.0f, 2.0f);
	vector3 q = p;
	vector3 r = p;
	A.transformPoint(&q);
	A.transformVector(&r);

	cout << "A = "               << endl << A << endl;
	cout << "B = "               << endl << B << endl;
	cout << "C = A*B = "         << endl << C << endl;
	cout << "D = transpose(A)= " << endl << D << endl;
	cout << "E = inverse(A) = "  << endl << E << endl;
	cout << "det = determinant(A) = "  << endl << det << endl;
	cout << "F = A*E = "         << endl << F << endl;
	cout << "p = "               << p << endl;
	cout << "q = P*A = "         << q << endl;
	cout << "r = P*A = "         << r << endl;


   	// RAY-plane intersection test
    plane plane0(1, 0, 0, 1);
	cout << "plane0 = "               << plane0 << endl;
	
	vector3 Q(2, 1, -1), P(-1, 1, 0);
	int ret = plane::isPointInsideOutside(plane0, Q);
	cout <<  "ret = " << ret << endl;	// ret = 1 (outside the plane)
	ret = plane::isPointInsideOutside(plane0, P);
	cout << "ret = " << ret << endl;	// ret = 0 (on the plane)
	P = plane::closestPointOnPlane(plane0, Q);
	cout << "P = " << P << endl; 	// P = (-1, 1, -1)

	RAY ray1, ray2, ray3;
	ray1.p = vector3(1, 0, 0);
	ray1.u = vector3(-1, -1, 0);
	ray2.p = vector3(1, 0, -2);
	ray2.u = vector3(1, 1, 1);
	ray3.p = vector3(1, 1, 0);
	ray3.u = vector3(1, 1, 1);
	vector3 out1, out2, out3;
	if (RayPlaneIntersection(plane0, ray1, out1))
		cout << "out1       = " << out1 << endl; // out1=(-1, -2, 0)
	if (RayPlaneIntersection(plane0, ray2, out2))
		cout << "out2       = " << out2 << endl; // nothing
	if (RayPlaneIntersection(plane0, ray3, out3))
		cout << "out3       = " << out3 << endl; // nothing
*/
    return 0;
}

